// Script edited from http://gregstoll.dyndns.org/googlemaps/mapjs.js
//<![CDATA[


/**********************************************************************************
These functions will show or display the map ...
**********************************************************************************/
function HideContent(mapdisplay) {
	document.getElementById(mapdisplay).style.display = "none";
}
function ShowContent(mapdisplay) {
	document.getElementById(mapdisplay).style.display = "";
}

	
	/**********************************************************************************
	Create the map & controls. We store the reset link as a function so we can reset the map to the original 
	position later if needed...
	**********************************************************************************/
	var map = new GMap(document.getElementById("map"));
    	map.addControl(new GLargeMapControl());
    	map.addControl(new GMapTypeControl());
    function resetMapPosition() {
        map.centerAndZoom(new GPoint(-117.971191,35.897889), 11);
    }
    resetMapPosition();


    var infolist = document.getElementById("infolist");
	
	
    // TODO - maybe make this one array of objects?
    var markerArray = new Array();
    var markerLocationNames = new Array();
    var markerEventNames = new Array();
    var markerPointsArray = new Array();
    var markerCallbacks = new Array();
    var markerTagStrings = new Array();
    var markerAddresses = new Array();
    var markerCityZips = new Array();
    var markersShown = new Array();
    var markerLength = 0;
    var tagToCountTable = {};
	
	
    function addTagToList(newTag) {
        if (tagToCountTable[newTag]) {
            tagToCountTable[newTag]++;
        } else {
            tagToCountTable[newTag] = 1;
        }
    }
	
	/**********************************************************************************
	This function will sort the tags field in the XML file by quantity....
	**********************************************************************************/
    function sortByCount(a, b) {
        return tagToCountTable[b] - tagToCountTable[a];
    }
    

	/**********************************************************************************
	This is the function to generate the custom markers on the Google map. Note there is a way to use standard 
	Google Markers too. Just read below.
	**********************************************************************************/
    function createMarker(point, markerBubble, index) {
        var icon = new GIcon();
					icon.image = imageurl;  
					icon.shadow = "images/mark_shadow.png"; // THIS LINE GETS THE DROP-SHADOW FILE
					icon.iconSize = new GSize(30, 34); // THIS LINE TELLS THE HEIGHT AND WIDTH DIMENSIONS OF THE MARKER
					icon.shadowSize = new GSize(57, 34); // THIS LINE TELLS THE HEIGHT AND WIDTH OF THE DROP-SHADOW
					icon.iconAnchor = new GPoint(9, 49);    
					icon.infoWindowAnchor = new GPoint(12, 3); // THIS LINE DETERMINES THE COORDINATES WHERE THE INFO BALLOON APPEARS
		
		var marker = new GMarker(point, icon); // TO USE CUSTOM MARKERS
		//var marker = new GMarker(point); // TO USE STANDARD GOOGLE MARKERS

		/**********************************************************************************
		This is the listener that tells when someone clicks on a marker and opens the info balloon...
		**********************************************************************************/
        GEvent.addListener(marker, "click", function() {
                marker.openInfoWindowHtml(markerBubble);
                });

        markerCallbacks[index] = function() {
            markerArray[index].openInfoWindowHtml(markerBubble);
        }

        return marker;
    }
	





    function filterTags(tag) {
        if (tag == '') {
            // special case - show all
            for (var i = 0; i < markerLength; i++) {
                if (markersShown[i] == false) {
                    // Display it.
                    markersShown[i] = true;
                    map.addOverlay(markerArray[i]);
                    var divInfo = document.getElementById("entry" + i);
                    divInfo.style.display = "";
                }
            }
            return;
        }
        var tagRE = new RegExp("\\|" + tag + "\\|");
			for (var i = 0; i < markerLength; i++) {
				if (markerTagStrings[i].match(tagRE)) {
					// Display the text and marker
					if (markersShown[i] == false) {
						// We need to display it.
						markersShown[i] = true;
						map.addOverlay(markerArray[i]);
						var divInfo = document.getElementById("entry" + i);
						divInfo.style.display = "";
					}
				} else {
					// Hide text and marker
					if (markersShown[i] == true) {
						// Hide it.
						markersShown[i] = false;
						map.removeOverlay(markerArray[i]);
						var divInfo = document.getElementById("entry" + i);
						divInfo.style.display = "none";
					}
				}
			}
    }




    /**********************************************************************************
	Download the data in the XML file and load it on the map....
	**********************************************************************************/
	var request = GXmlHttp.create();
    request.open("GET", "includes/datasheet.xml", true);
    //request.open("GET", xmlFileName, true);
    request.onreadystatechange = function() {
        if (request.readyState == 4) {
            var xmlDoc = request.responseXML;
            var markers = xmlDoc.documentElement.getElementsByTagName("marker");
            markerLength = markers.length;
          
            
			/**********************************************************************************
			Loops through all the records in the XML file ... I think ...
			**********************************************************************************/
			for (var i = 0; i < markers.length; i++) {
            	markerPointsArray[i] = new GPoint(parseFloat(markers[i].getAttribute("lng")),
            	parseFloat(markers[i].getAttribute("lat")));
            	markerEventNames[i] = new String(markers[i].getAttribute("event"));
            	
            	                
                /**********************************************************************************
				'destination' is just a way to combine lines of the location so they can be sent to 
				maps.google.com. You can send the street address or the latitude and longitude...					
				**********************************************************************************/
				//var destination = markers[i].getAttribute("add1") + ',' + markers[i].getAttribute("add2");  //RETURNS LOCATION BASED ON STREET ADDRESS
				var destination = markers[i].getAttribute("lat") + ',' + markers[i].getAttribute("lng");  //RETURNS LOCATION BASED ON LATITUDE AND LONGITUDE
				
				
				/**********************************************************************************
				'dirLink' is the "Get Directions To Location Below" link. It uses the 'destination' variable 
				and contains a form...
				*********************************************************************************/
				var dirLink = '<form action="http://maps.google.com/maps" target="_blank" method="get"><label for="saddr">Enter Your Starting Address Here:<br>EXAMPLE: &quot;1 Main St, Cleveland, OH 44144&quot;</span></label><br><input type="text" SIZE=40 name="saddr" id="saddr" value="" /><br><INPUT ID="SUBMIT" TYPE="SUBMIT" VALUE="Get Directions To Location Below"><input type="hidden" name="daddr" value="'+destination+'" /><input type="hidden" name="hl" value="en" /></form>';
				
				
				/**********************************************************************************
				Show the following HTML in the info window when a marker is clicked...
				The "if" statement determines if there is an active URL or not. If so, it shows a link. If not,
				it leaves the URL line blank.
				**********************************************************************************/
				if (markers[i].getAttribute("url") == '0') {
						var html = '<b>Event:</b><br>'+ markers[i].getAttribute("event")+'<br>'+
							markers[i].getAttribute("time")+'<br>'+
							markers[i].getAttribute("recurrence")+'<p>'+
							'<b>Location:</b><br>'+ markers[i].getAttribute("locationname")+'<br>'+
							markers[i].getAttribute("add1")+'<br>'+
							markers[i].getAttribute("add2")+'<p><span class="smalltext">';
				} else {
						var html = '<b>Event:</b><br>'+ markers[i].getAttribute("event")+'<br>'+
							markers[i].getAttribute("time")+'<br>'+
							markers[i].getAttribute("recurrence")+'<br>'+
							'<a href="'+ markers[i].getAttribute("url") +'" target="_blank">'+ markers[i].getAttribute("url") +'</a><p>'+ // DISPLAYS URL IN INFO BALLOON
							//'<a href="'+ markers[i].getAttribute("url") +'" target="_blank">Click Here For Website</a><p>'+ // DISPLAYS "CLICK HERE FOR WEBSITE" IN INFO BALLOON
							'<b>Location:</b><br>'+ markers[i].getAttribute("locationname")+'<br>'+
							markers[i].getAttribute("add1")+'<br>'+
							markers[i].getAttribute("add2")+'<p><span class="smalltext">';
				}
                
                
            	/**********************************************************************************
				The 'switch' statement below takes info from the XML file to figure out which marker to display for 
				a given record...
				**********************************************************************************/								
				switch (markers[i].getAttribute("tags")) {
				   case "|Mondays|": imageurl = "images/mark_mon.png"; break;
				   case "|Tuesdays|": imageurl = "images/mark_tue.png"; break;
				   case "|Wednesdays|": imageurl = "images/mark_wed.png"; break;
				   case "|Thursdays|": imageurl = "images/mark_thu.png"; break;
				   case "|Fridays|": imageurl = "images/mark_fri.png"; break;
				   case "|Saturdays|": imageurl = "images/mark_sat.png"; break;
				   case "|Sundays|": imageurl = "images/mark_sun.png"; break;
				   case "|Food/Bar|": imageurl = "images/mark_eat.png"; break;
				   case "|BikeFest|": imageurl = "images/mark_event.png"; break;
				   default: imageurl = 'unknown';
				}
                               
                
                var markerBubble = html + dirLink;
                	markerArray[i] = createMarker(markerPointsArray[i], markerBubble, i);map.addOverlay(markerArray[i]);
                	markerTagStrings[i] = new String(markers[i].getAttribute("tags"));
           
                
                var listing = markers[i].getAttribute("add1")+', '+ markers[i].getAttribute("add2")+' ';
                
                
				var entry = document.createElement("div");
                	entry.setAttribute("id", "entry" + i);
                	entry.setAttribute("style", "");
                var boldPart = document.createElement("b");
                var linkPart = document.createElement("a");
                	linkPart.setAttribute("href", "javascript:callback" + i + "();");
                var boldText = document.createTextNode(markerEventNames[i]);
                	boldPart.appendChild(boldText);
                	//linkPart.appendChild(boldPart); //MAKES CALLBACK TEXT BOLD
                	linkPart.appendChild(boldText); //MAKES CALLBACK TEXT NORMAL
					

                /**********************************************************************************
				Get rid of <br/>'s in text....
				**********************************************************************************/
				var captionPart = document.createTextNode(" - " + listing.replace(/<br\/>/g, " "));


				/**********************************************************************************
				Code that shows master list of callbacks...
				**********************************************************************************/
                var tagPart = document.createTextNode(" ("); //THE DIVIDER THAT APPEARS BEFORE THE TAG
                var tagsPart = document.createElement("span");
                var tempString = markerTagStrings[i];
                	// Skip the first '|'
                	tempString = tempString.substring(1);
                
                
                for (; tempString.length > 0;) {
                    var nextPipe = tempString.indexOf('|');
	                    if (nextPipe == -1) {
	                        // String is busticated.
	                        tempString = ''
	                    } else {
	                        var nextTag = tempString.substring(0, nextPipe);
	                        	addTagToList(nextTag);
	                        // Add links to tags
	                        	tempString = tempString.substring(nextPipe+1);
	                        var tempLinkPart = document.createElement("a");
	                        	tempLinkPart.setAttribute("href", "javascript:filterTags('" + nextTag + "');");
	                       	var tempLinkText = document.createTextNode(nextTag);
	                        var space = document.createTextNode(")"); //THE DIVIDER THAT APPEARS AFTER THE TAG
	                        	tempLinkPart.appendChild(tempLinkText);
								tagsPart.appendChild(tempLinkPart);
	                        	tagsPart.appendChild(space);
	                    }
                	}
								
				entry.appendChild(linkPart);
                //entry.appendChild(captionPart); //ADDS THE ADDRESS CONTENT TO THE LINK
                entry.appendChild(tagPart); //ADDS THE DIVIDER BETWEEN THE ADDRESS AND THE TAG
                entry.appendChild(tagsPart); //ADDS THE TAG TO THE LINK
                infolist.appendChild(entry);
                
            }

            
			/**********************************************************************************
			Sort the horizontal list and count the totals...
			**********************************************************************************/
            allTags = new Array();
            var j = 0;
	            for (tag in tagToCountTable) {
	                allTags[j] = tag;
	                j++;
	            }
            allTags.sort(sortByCount); // SORT THE HORIZONAL TAGS BY LARGEST NUMBER
            //allTags.sort(); // SORT THE HORIZONTAL TAGS ALPHABETICALLY
 
            
			/**********************************************************************************
			Add the horizontal list of ALL tags...
			**********************************************************************************/
            var tags = document.getElementById("tags");
            var tagAllEntry = document.createElement("a");
            	tagAllEntry.setAttribute("href", "javascript:filterTags('');");
            var tagAllText = document.createTextNode(' Show All(' + markerLength + ')');
            	tagAllEntry.appendChild(tagAllText);
            	tags.appendChild(tagAllEntry);
            var space = document.createTextNode(' '); // CHARACTERS AFTER THE GRAND TOTAL IS SHOWN FOR ALL TAGS
            	tags.appendChild(space);


            /**********************************************************************************
			Add the horizontal list of INDIVIDUAL tags....
			**********************************************************************************/
            for (var j = 0; j < allTags.length; j++) {
                var tempLinkEntry = document.createElement("a");
                	tempLinkEntry.setAttribute("href", "javascript:filterTags('" + allTags[j] + "');");
				var tempLinkText = document.createTextNode(allTags[j] + "(" + tagToCountTable[allTags[j]] + ")");
                	tempLinkEntry.appendChild(tempLinkText);
                	tags.appendChild(tempLinkEntry);
                var space = document.createTextNode(' '); // CHARACTERS AFTER THE GRAND TOTAL IS SHOWN FOR INDIVIDUAL TAGS
                	tags.appendChild(space);
            }
            
            
            /**********************************************************************************
			Activates the callback links in all the text and makes them functional....
			**********************************************************************************/        
            for (var j = 0; j < markerLength; j++) {
                markersShown[j] = true;
                eval('callback' + j + ' = function() {markerCallbacks[' + j + ']();}');
            }


        } 
        
    }
    
    request.send(null);
    //]]>

